stages:
  - lint
  - playbook

variables:
  PLAYBOOK: "playbooks/test.yml"
  LIMIT: "all"
  EXTRAVARS: "empty=true"
  TAGS: "all"

.run-playbook:
  image:
    name: devupsen/ansible:6.5.0
  before_script:
    - export ANSIBLE_CONFIG=./ansible.cfg
    - eval $(ssh-agent -s)
    - echo "$SSH_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
  script:
    - echo $PLAYBOOK
    - ansible-playbook playbooks/$PLAYBOOK -l $LIMIT -e $EXTRAVARS -t $TAGS
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web"'
      when: manual

ansible-linter:
  stage: lint
  image:
    name: devupsen/ansible:6.5.0
  script:
    - ansible-lint
  only:
    - merge_requests

docker:
  stage: playbook
  extends: .run-playbook
  variables:
    PLAYBOOK: "docker.yaml"
    LIMIT: "devupsen"

runner:
  stage: playbook
  extends: .run-playbook
  variables:
    PLAYBOOK: "gitlab-runner.yaml"

vault:
  stage: playbook
  extends: .run-playbook
  variables:
    PLAYBOOK: "vault.yaml"
    EXTRAVARS: 'postgres_vault.password="$VAULT_POSTGRES_PASSWORD"'

main:
  stage: playbook
  extends: .run-playbook
  variables:
    PLAYBOOK: "nginx.yaml"
    LIMIT: "balancer-green.devupsen.ru,balancer-yellow.devupsen.ru"
    TAGS: "main"

second:
  stage: playbook
  extends: .run-playbook
  variables:
    PLAYBOOK: "nginx.yaml"
    LIMIT: "balancer-red.devupsen.ru"
    TAGS: "backup-node,main"
